/*****************************************************************************
*
*   Analog Devices, Inc.
*   ADSP-BF537 EZ-Kit Lite
*   Networked Audio Client
*
******************************************************************************
*
*   File        :   audioflow.h
*
*   Description :   This file contains audioflow thread header information.
*
******************************************************************************
*   Revision History
******************************************************************************
*   date        rev     by      description
*-----------------------------------------------------------------------------
*   02.27.07    01.02h  KCK     Original release.
*****************************************************************************/

#ifndef _audioflow_H_
#define _audioflow_H_

#pragma diag(push)
#pragma diag(suppress: 177,401,451,826,831,1462)

#include "VDK.h"
#pragma diag(pop)

#ifdef __ECC__	/* for C/C++ access */
#ifdef __cplusplus
extern "C" void audioflow_InitFunction(void**, VDK::Thread::ThreadCreationBlock *);
#else
extern "C" void audioflow_InitFunction(void**, VDK_ThreadCreationBlock *);
#endif
extern "C" void audioflow_DestroyFunction(void**);
extern "C" int  audioflow_ErrorFunction(void**);
extern "C" void audioflow_RunFunction(void**);
#endif /* __ECC__ */

#ifdef __cplusplus
#include <new>

class audioflow_Wrapper : public VDK::Thread
{
public:
    audioflow_Wrapper(VDK::ThreadCreationBlock &t)
        : VDK::Thread(t)
    { audioflow_InitFunction(&m_DataPtr, &t); }

    ~audioflow_Wrapper()
    { audioflow_DestroyFunction(&m_DataPtr); }

    int ErrorHandler()
    { 
      return audioflow_ErrorFunction(&m_DataPtr);
     }

    void Run()
    { audioflow_RunFunction(&m_DataPtr); }

    static VDK::Thread* Create(VDK::Thread::ThreadCreationBlock &t)
    { return new (t) audioflow_Wrapper(t); }
};

#endif /* __cplusplus */
#endif /* _audioflow_H_ */

/* ========================================================================== */
