/*****************************************************************************
*
*   Analog Devices, Inc.
*   ADSP-BF537 EZ-Kit Lite
*   Networked Audio Client
*
******************************************************************************
*
*   File        :   keepalive.h
*
*   Description :   This file contains the keepalive thread header information.
*
******************************************************************************
*   Revision History
******************************************************************************
*   date        rev     by      description
*-----------------------------------------------------------------------------
*   02.27.07    01.02h  KCK     Original release.
*****************************************************************************/

#ifndef _keepalive_H_
#define _keepalive_H_

#pragma diag(push)
#pragma diag(suppress: 177,401,451,826,831,1462)

#include "VDK.h"
#pragma diag(pop)

#ifdef __ECC__	/* for C/C++ access */
#ifdef __cplusplus
extern "C" void keepalive_InitFunction(void**, VDK::Thread::ThreadCreationBlock *);
#else
extern "C" void keepalive_InitFunction(void**, VDK_ThreadCreationBlock *);
#endif
extern "C" void keepalive_DestroyFunction(void**);
extern "C" int  keepalive_ErrorFunction(void**);
extern "C" void keepalive_RunFunction(void**);
#endif /* __ECC__ */

#ifdef __cplusplus
#include <new>

class keepalive_Wrapper : public VDK::Thread
{
public:
    keepalive_Wrapper(VDK::ThreadCreationBlock &t)
        : VDK::Thread(t)
    { keepalive_InitFunction(&m_DataPtr, &t); }

    ~keepalive_Wrapper()
    { keepalive_DestroyFunction(&m_DataPtr); }

    int ErrorHandler()
    { 
      return keepalive_ErrorFunction(&m_DataPtr);
     }

    void Run()
    { keepalive_RunFunction(&m_DataPtr); }

    static VDK::Thread* Create(VDK::Thread::ThreadCreationBlock &t)
    { return new (t) keepalive_Wrapper(t); }
};

#endif /* __cplusplus */
#endif /* _keepalive_H_ */

/* ========================================================================== */
