/*****************************************************************************
*
*   Analog Devices, Inc.
*   ADSP-BF537 EZ-Kit Lite
*   Networked Audio Server
*
******************************************************************************
*
*   File        :   audiosend.h
*
*   Description :   This file contains header information for the audiosend
*                   thread.
*
******************************************************************************
*   Revision History
******************************************************************************
*   date        rev     by      description
*-----------------------------------------------------------------------------
*   02.27.07    01.02h  KCK     Original release.
*****************************************************************************/

#ifndef _audiosend_H_
#define _audiosend_H_

#pragma diag(push)
#pragma diag(suppress: 177,401,451,826,831,1462)

#include "VDK.h"
#pragma diag(pop)

#ifdef __ECC__	/* for C/C++ access */
#ifdef __cplusplus
extern "C" void audiosend_InitFunction(void**, VDK::Thread::ThreadCreationBlock *);
#else
extern "C" void audiosend_InitFunction(void**, VDK_ThreadCreationBlock *);
#endif
extern "C" void audiosend_DestroyFunction(void**);
extern "C" int  audiosend_ErrorFunction(void**);
extern "C" void audiosend_RunFunction(void**);
#endif /* __ECC__ */

#ifdef __cplusplus
#include <new>

class audiosend_Wrapper : public VDK::Thread
{
public:
    audiosend_Wrapper(VDK::ThreadCreationBlock &t)
        : VDK::Thread(t)
    { audiosend_InitFunction(&m_DataPtr, &t); }

    ~audiosend_Wrapper()
    { audiosend_DestroyFunction(&m_DataPtr); }

    int ErrorHandler()
    { 
      return audiosend_ErrorFunction(&m_DataPtr);
     }

    void Run()
    { audiosend_RunFunction(&m_DataPtr); }

    static VDK::Thread* Create(VDK::Thread::ThreadCreationBlock &t)
    { return new (t) audiosend_Wrapper(t); }
};

#endif /* __cplusplus */
#endif /* _audiosend_H_ */

/* ========================================================================== */
